; This example program shows how to use the serial hardware
; with hserin command (rather than background receive)
; Serial hardware pins (C6 and C7) connected via MAX232 to
; computers serial port. Output 1 connected to an LED.

; In normal use the LED toggles on a timeout. When a serial receive
; occurs (qualifier "a" first required) the next 3 bytes are echoed back out for testing purposes.

; set picaxe type
;#picaxe 28x2
#com 4
; open terminal after download
#terminal 9600
; Don't forget to move serial cable to the hardware pins!


	; setup serial hardware 
	; at 9600 with no background receive
	hsersetup b9600_8,%110
	
	'loop waiting for a byte
main:
	
	; sp address 0, receive 3 bytes after the qualifier "a"
	hserin [5000,timeout],0,3,("a")
	
	ptr = 0	 	' set scatchpad pointer back to 0
			 	' and then output the next 3 bytes
	hserout 0,(#ptr,"=",@ptrinc,cr,lf)
	hserout 0,(#ptr,"=",@ptrinc,cr,lf)
	hserout 0,(#ptr,"=",@ptr,cr,lf)
	goto main

	; toggle the LED upon a timeout so we know its working
timeout:
	toggle 1
	goto main


