'PROGRAM: PRT001.BAS

'BASIC Stamp program that demonstrates
'how to use the serial Printer Module.

'Connect the Printer Module to the Stamp.
'Switch the printer OFF, connect the printer
'cable to the module. Power up the Stamp,
'and then switch the printer ON. Then download 
'this program.

symbol	S_OUT	= 	7		'serial Printer output (output)
symbol	i	= 	b5		'scratchpad counter

'Define useful ASCII characters
symbol	STX	=	2		'Start of text ("wake-up")
symbol	ETX	=	3		'End of text ("sleep")
symbol	TAB	=	9		'Tab
symbol	LF	=	10		'Line Feed
symbol	FF	=	12		'Form Feed

'Note that carriage return CR = 13 is a pre-defined constant 
'within the Stamp editor and therefore does not require a 
'separate 'symbol' definition.

init:	'Make serial pin an output, and leave high for 5ms
	'This provides time for the printer module serial
	'input to reset. 
	
	high S_OUT			'Make pin7 high output.				
	pause 5				'Short pause.
	
main:	'Wake up printer module via sending STX command.
	serout S_OUT,T2400,(STX)
	
	'Print 'Hello' message.
	serout S_OUT,T2400,("Hello",CR,LF)

	'Note all lines must always be followed by CR then LF.

	'Print ten more lines.
	for i = 1 to 10
	   serout S_OUT,T2400,(TAB,"This is line ",#i,CR,LF)
	next i	

	'Note the # before the variable i. This ensures
	'variable numbers are transmitted as a string of
	'ASCII characters rather than as a single byte.

	'Note also some printers print very near left edge.
	'Printing a TAB before each line helps create a margin.

	'Now finish printing by sending form-feed character.
	serout S_OUT,T2400,(FF)

	'Finally send printer driver module to sleep.	
	serout S_OUT,T2400,(ETX)

	end

