#picaxe 20x2
#no_table

' PICAXE-20X2 sample program for Lego NXT Sensors

' Hitechnic NXT Acceleration Sensor (part MS1040)


symbol x_lower = b0
symbol x_higher = b1
symbol x_axis = w0	' w0 is made up of b1 and b0
symbol y_lower = b2
symbol y_higher = b3
symbol y_axis = w1	' w1 is made up of b3 and b2
symbol z_lower = b4
symbol z_higher = b5
symbol z_axis = w2	' w2 is made up of b5 and b4


' Wires on NXT jack plug.
' Wire colours may vary. Pin 1 is always end nearest latch.
' 1 White	No connect
' 2 Black	0V
' 3 Red	0V
' 4 Green	V+ (4.5V or 5V)
' 5 Yellow	SCL
' 6 Blue	SDA
' Do not use i2c pullup resistor - already provided within sensor.


init:

	'Slave address is $02
	hi2csetup i2cmaster, $02, i2cslow, i2cbyte


main:
	; read values
	hi2cin $42,(x_higher, y_higher, z_higher, x_lower, y_lower, z_lower)	
	
	'if you just want 8 bit numbers
	'x_axis = x_higher
	'y_axis = y_higher
	'z_axis = z_higher
	
	'of if you want 10 bit numbers that are right aligned
	x_axis = x_axis >> 6
	y_axis = y_axis >> 6
	z_axis = z_axis >> 6
		
	; debug display
	debug
	; wait 1 second then loop
	pause 1000
	goto main


