#picaxe 20x2
#no_table

' PICAXE-20X2 sample program for two Hitechnic NXT Sensors

' **** AXE216 i2c Experimenter Board Setup ****
' J1	External Power	Fitted (4.5V)
' J2	SCL Pullup		Not fitted (pullup is in sensor)
' J3	SDA Pullup		Not fitted (pullup is in sensor)
' H2	9V Power		Fitted (9V)


' **** Hitechnic NXT Compass Sensor (part MS1034) ****
' **** Remember Compasss MUST be kept level ****

symbol heading_2degree = b0
symbol heading_adder = b1
symbol heading = w1	


' **** Hitechnic NXT IRSeeker V2 (part NSK1042) ****
' **** Remember IRSeeker V2 requires 9V power on wire 1 ****
' **** Tested using a Hitechnic robocup ball (version RCJ-05) ****

symbol ac_direction = b10
symbol sensor1_ac = b11
symbol sensor2_ac = b12
symbol sensor3_ac = b13
symbol sensor4_ac = b14
symbol sensor5_ac = b15

' Wires on NXT jack plug.
' Wire colours may vary. Pin 1 is always end nearest latch.
' 1 White	+9V
' 2 Black	0V
' 3 Red	0V
' 4 Green	V+ (4.5V or 5V)
' 5 Yellow	SCL
' 6 Blue	SDA
' Do not use i2c pullup resistor - already provided within sensor.

init:

	'Slave address of compasss is $02
	'Slave address of IRSeeker2 is $10
	hi2csetup i2cmaster, $02, i2cslow, i2cbyte

	'Optional configuration of compass
	hi2cout [$02],$41,($00)		; normal mode
	;hi2cout [$02],$41,($43)	; hard iron calibrate mode
	pause 100


	'Optional configuration of IRSEEKER2
 	hi2cout [$10],$41,($00)  ; AC mode (1200 Hz) 	RCJ-05 Ball switch pos. D 
 	;hi2cout [$10],$41,($01) ; AC mode (600 Hz) 	RCJ-05 Ball switch pos. C
 	;hi2cout [$10],$41,($02) ; DC mode 		 	RCJ-05 Ball switch pos. B

 	pause 100

main:
	; read values from compass (address $02)
	hi2cin [$02], $42,(heading_2degree, heading_adder)	
	
	heading = heading_2degree * 2 + heading_adder
	
	; read values from IRSeeker  (address $10)
	hi2cin [$10], $49,(ac_direction,  sensor1_ac, sensor2_ac, sensor3_ac, sensor4_ac, sensor5_ac)	
	
	; debug display
	debug
	; wait 1 second then loop
	pause 1000
	goto main


