' EH1 Hexwalker PICAXE-08M Program
' www.picaxe.co.uk
' CPS 28-04-05

' Program to make the EH1 Hexwalker walk forwards
' until input switch actiavted. Then reverse and
' turn before going off forwards again.

' For use with AXE024 PICAXE-08M Servo driver board

'*** Input Output Pins

'0 (not used)
'1 centre servo 
'2 right side servo 
'3 bumper switch
'4 left side servo


'*** Program constants

' Delay to slow down servo motion (30ms default) 
symbol servo_delay = 30 		

' Number of steps backwards and turning
symbol no_back_steps = 8
symbol no_turn_steps = 5

'*** Initialisation

init:	
' set servos to known position
	servo 1,120
	servo 2,120
	servo 4,120
	pause servo_delay

' set interrupt to occur when input3 high
	setint %00001000,%00001000 

'*** Move forward

move_forward:
	for b1 = 120 to 180
		servo 1,b1
		pause servo_delay
	next b1	

	for b1 = 120 to 180
		servo 4,b1
		servo 2,b1
		pause servo_delay
	next b1

	for b1 = 180 to 120 step -1
		servo 1,b1
		pause servo_delay
	next b1

	for b1 = 180 to 120 step -1 
		servo 4,b1
		servo 2,b1
		pause servo_delay
	next b1

	goto move_forward


'*** Interrupt sub

' When interrupt occurs back up and then turn


interrupt:

'Backwards
	for b2 = 1 to no_back_steps

		for b1 = 180 to 120 step -1
			servo 1,b1
			pause servo_delay
		next b1


		for b1 = 120 to 180
			servo 4,b1
			servo 2,b1
			pause servo_delay
		next b1

		for b1 = 120 to 180
			servo 1,b1
			pause servo_delay
		next b1	


		for b1 = 180 to 120 step -1 
			servo 4,b1
			servo 2,b1
			pause servo_delay
		next b1

	next b2

'Turn

	for b2 = 1 to no_turn_steps

		for b1 = 180 to 120 step -1
			servo 1,b1
			pause servo_delay
		next b1


		let b2 = 180
		for b1 = 120 to 180
			servo 4,b1
			servo 2,b2
			let b2 = b2 - 1
			pause servo_delay
		next b1

		for b1 = 120 to 180
			servo 1,b1
			pause servo_delay
		next b1	

		let b2 = 120
		for b1 = 180 to 120 step -1 
			servo 4,b1
			servo 2,b2
			let b2 = b2 + 1
			pause servo_delay
		next b1

	next b2

'Reset interrupt
	setint %00001000,%00001000 
	return


















